/*

----------------------------------
Makro: DIRECTORY_CREATE
Nzev: Vytvoen adrese na disku
       Creates directory on disk
Verze: 2.2
Autor: jan.ruzicka@cze.sas.com
----------------------------------

-------------------
POPIS - DESCRIPTION
-------------------

Makro vytv adres na disku.
Macro creates directory on disk.

----------------
SYNTAXE - SYNTAX
----------------

%macro directory_create
(
    dir  *** Specifikace vytvenho adrese
             Directory specification
)

----------------------------------
HISTORIE ZMN - HISTORY OF CHANGES
----------------------------------

01.11.2003  Verze 1.40
            + zapracovn do jednotnho frameworku SAS maker
              rewriten as part of the framework
15.01.2004  Verze 1.41
            + popis v anglitin
              description in english
31.01.2007  Verze 2.0
            + vyuit funkce DCREATE v SAS 9.1+
              DCREATE function utilization in SAS 9.1+
31.10.2008  Verze 2.2

---------------------------------
PLNY NA VYLEPEN - FUTURE PLANS
---------------------------------

-------------------
PKLADY - EXAMPLES
-------------------

%directory_create(c:\temp\test);

----------------
POZNMKY - NOTES
----------------

Pipomnky a npady k vylepen vtny.
Ideas to improve are welcome.

*/

%macro directory_create
(
    dir
) / des='Creates directory';

%put;
%put NOTE: Macro DIRECTORY_CREATE version 2.2;
%put;

%if %sysfunc(fileexist(&dir))=0 %then %do;
    %if %sysevalf(&sysver<9.1) %then %do;
        systask command "mkdir &dir" wait%str(;);
    %end;
    %else %do;
        %local credir pos len dlm n i;
        %let pos=0;
        %let len=0;
        %let dlm=/\;
        %let n=%util_countwords(&dir,delimiter=&dlm);
        %do i=1 %to &n;
            %syscall qscan(dir,i,pos,len,dlm);
            %if &i=1 and &pos=1 %then %let credir=%qsysfunc(dcreate(%qsubstr(&dir,&pos,&len)));
            %else %let credir=%qsysfunc(dcreate(%qsubstr(&dir,&pos,&len),%qsubstr(&dir,1,&pos-1)));
            %if &credir ne %then %put NOTE: Creating folder &credir;
        %end;
    %end;
%end;

%mend directory_create;
