/*

------------------------------
Makro: DS_LIBNAME
Nzev: Vrac knihovnu datasetu
       Returns dataset libname
Verze: 2.02
Autor: jan.ruzicka@cze.sas.com
------------------------------

-------------------
POPIS - DESCRIPTION
-------------------

Tato makro funkce vrac knihovnu datasetu definovanho parametrem.
This macro function returns dataset libname.

----------------
SYNTAXE - SYNTAX
----------------

%ds_libname
(
    data,    *** specifikace datasetu
                 dataset specification
    debug=no *** vpis chybovch hlek do LOG
                 list erors to LOG
)

----------------------------------
HISTORIE ZMN - HISTORY OF CHANGES
----------------------------------

01.11.2003  Verze 1.40
            + zapracovn do jednotnho frameworku SAS maker
              rewriten as part of the framework
15.01.2004  Verze 1.41
            + popis v anglitin
              description in english
12.11.2007  Verze 2.02

---------------------------------
PLNY NA VYLEPEN - FUTURE PLANS
---------------------------------

-------------------
PKLADY - EXAMPLES
-------------------

*** 1;

%put Library of SASHELP.AIR is "%ds_libname(sashelp.air)";

----------------
POZNMKY - NOTES
----------------

Pipomnky a npady k vylepen vtny.
Ideas to improve are welcome.

*/

%macro ds_libname
(
    data,
    debug=no
) / des='Returns dataset libname';

%local dsid;

%let data=%nrbquote(&data);
%let debug=%qupcase(&debug);

%let dsid=%sysfunc(open(&data));
%if &dsid %then %do;
    %qsysfunc(attrc(&dsid,lib))
    %let dsid=%sysfunc(close(&dsid));
%end;
%else %if &debug=YES %then %put ERROR: Cannot read dataset &data..;

%mend ds_libname;
