
%let target=bad30;
%let data=indata.accepts;
%let openvar=datappl;
%let datevar=dat30;
%let out=cohorts;

data &out;
set &data (keep=&openvar &target &datevar
           rename=(&openvar=DateOpen &target=Target &datevar=__date)) end=__finish;
if target and __date ne . and dateopen ne . then do;
    DateBad=intck('qtr',dateopen,__date);
    *DateBad=int(yrdif(dateopen,__date,'act/act')*4);
    dateopen=intnx('month',dateopen,0);
    __dateopenmax=max(__dateopenmax,dateopen);
    __datebadmin=min(__datebadmin,datebad);
    __datebadmax=max(__datebadmax,datebad);
    retain __dateopenmax __datebadmin __datebadmax;
    output;
end;
if __finish then do;
    call symput('dateopenmax',compress(put(__dateopenmax,best.)));
    call symput('datebadmin',compress(put(__datebadmin,best.)));
    call symput('datebadmax',compress(put(__datebadmax,best.)));
end;
format dateopen &dateopenformat;
*drop __:;
run;

%put %sysfunc(putn(&dateopenmax,ddmmyyp10.));
%put &datebadmin;
%put &datebadmax;

proc freq data=&out noprint;
table dateopen / out=__temp (keep=dateopen count rename=(count=CountTotal));
table dateopen*datebad / cumcol out=&out (keep=dateopen datebad count) sparse;
run;

data &out.1;
merge &out __temp;
by dateopen;
if first.dateopen then TargetCum=.;
else do;
    targetcum+(count/counttotal);
    a=intnx("month",dateopen,datebad*&datebadfreq-&datebadfreq);
    if a>&dateopenmax then targetcum=.;
    format a ddmmyyp10.;
    output;
end;
run;

ods html path="&appl_root" file='2.cohorts.html';
title "Cohort analysis for &target";
proc tabulate data=&out.1 missing format=percent8.4;
class dateopen datebad;
var targetcum;
table dateopen,datebad*targetcum;
run;
ods html close;

