/*

------------------------------------------
Makro: UTIL_COUNTWORDS
Nzev: Vrt poet slov ve svm agrumentu
       Returns number of words in argument
Verze: 1.42
Autor: jan.ruzicka@cze.sas.com
------------------------------------------

-------------------
POPIS - DESCRIPTION
-------------------

Makro vrt poet slov v svm argumentu (parametr QUERY). Je mon specifikovat, kter znaky jsou
povaovny za oddlovae.

Macro returns number of words in argument (option QUERY). It could be specified, which characters
are supposed to be delimiters.

----------------
SYNTAXE - SYNTAX
----------------

%util_countwords
(
    query,     *** argument
                   argument
    delimiter= *** oddlovae (nepovinn parametr)
                   delimiters (optional parameter)
)

----------------------------------
HISTORIE ZMN - HISTORY OF CHANGES
----------------------------------

   11/2001  Verze 1.00
01.09.2002  Verze 1.10
            - prava parametr
              changing of options
01.11.2003  Verze 1.40
            + zapracovn do jednotnho frameworku SAS maker
              rewriten as part of the framework
            - zmna nzvu makra
              change macro name
15.01.2004  Verze 1.41
            + popis v anglitin
              description in english
16.02.2004  Verze 1.42

---------------------------------
PLNY NA VYLEPEN - FUTURE PLANS
---------------------------------

-------------------
PKLADY - EXAMPLES
-------------------

%put %util_countwords(ahoj babi+nazdar babi);
%put %util_countwords(ahoj babi+nazdar babi;ahoj babi moje;ahoj babi zlat,
                      delimiter=;);

----------------
POZNMKY - NOTES
----------------

Pipomnky a npady k vylepen vtny.
Ideas to improve are welcome.

*/

%macro util_countwords
(
    query,
    delimiter=
) / des='Returns number of words in argument';

%local i;

%let i=1;
%if "&delimiter"="" %then %do %while(%quote(%scan(&query,&i)) ne);
    %let i=%eval(&i+1);
%end;
%else %do %while(%quote(%scan(&query,&i,&delimiter)) ne);
    %let i=%eval(&i+1);
%end;
%eval(&i-1)

%mend util_countwords;
