%macro woes
(data,out,inputs,target,weight=);

proc summary data=&data;
%if &weight ne %then %do;
    weight &weight;
%end;
class &inputs;
ways 0 1;
output out=&out (drop=_freq_) sum(&target)=__n1
%if &weight ne %then %do;
    sumwgt(&target)=__n
%end;
%else %do;
    n(&target)=__n
%end;
;
run;


data &out;
set &out end=__finish;
by _type_;
attrib
    __name  length=$32
    __value length=$100
    __type  length=$1
    __woe   label='WOE' format=8.2
;
if _n_=1 then do;
    __all_n=__n;
    __all_n1=__n1;
    __all_n0=__n-__n1;
    retain __all_n:;
end;
else do;
    if first._type_ then __i+1;
    __p=__n/__all_n;
    __n0=__n-__n1;
    __p1=__n1/__all_n1;
    __p0=__n0/__all_n0;
    __r1=__n1/__n;
    __r0=__n0/__n;
    __woe=log((__p0)/(__p1))*100;
    __all_iv+(__p0-__p1)*__woe/100;
    __name=scan("&inputs",-__i);
    %do i=1 %to %util_countwords(&inputs);
        if __name="%scan(&inputs,&i)" then do;
            %if %substr(%var_length(&out,%scan(&inputs,&i)),1,1)=$
            %then %do;
                __value=putc(%scan(&inputs,&i),vformat(%scan(&inputs,&i)));
                __type='C';
            %end;
            %else %do;
                __value=putn(%scan(&inputs,&i),vformat(%scan(&inputs,&i)));;
                __type='N';
            %end;
        end;
    %end;
    __name=vnamex(__name);
    output;
end;
keep __name __value __type __woe;
run;
%mend woes;
options mprint;


%macro woesadd(woes,data,out);
data _null_;
set &woes end=__finish;
if _n_=1 then do;
    call execute("data &out;");
    call execute("set &data;");
end;
if __type='C'
    then call execute('if putc('||trim(__name)||',vformat('||trim(__name)||'))="'||trim(__value)||'" then '||trim(__name)||'_WOE='||put(__woe,best.)||';');
    else call execute('if putn('||trim(__name)||',vformat('||trim(__name)||'))="'||trim(__value)||'" then '||trim(__name)||'_WOE='||put(__woe,best.)||';');
if __finish then call execute('run;');
run;
%mend woesadd;

